// Telegrammer - Telegram Bot Swift SDK.
// This file is autogenerated by API/generate_wrappers.rb script.


import HTTP

public extension Bot {

    /// Parameters container struct for `getChatMembersCount` method
    public struct GetChatMembersCountParams: JSONEncodable {

        /// Unique identifier for the target chat or username of the target supergroup or channel (in the format @channelusername)
        var chatId: ChatId

        /// Custom keys for coding/decoding `GetChatMembersCountParams` struct
        enum CodingKeys: String, CodingKey {
            case chatId = "chat_id"
        }

        public init(chatId: ChatId) {
            self.chatId = chatId
        }
    }

    /**
     Use this method to get the number of members in a chat. Returns Int on success.

     SeeAlso Telegram Bot API Reference:
     [GetChatMembersCountParams](https://core.telegram.org/bots/api#getchatmemberscount)
     
     - Parameters:
         - params: Parameters container, see `GetChatMembersCountParams` struct
     - Throws: Throws on errors
     - Returns: Future of `Int` type
     */
    @discardableResult
    public func getChatMembersCount(params: GetChatMembersCountParams) throws -> Future<Int> {
        let body = try httpBody(for: params)
        let headers = httpHeaders(for: params)
        let response: Future<TelegramContainer<Int>>
        response = try client.respond(endpoint: "getChatMembersCount", body: body, headers: headers)
        return response.flatMap(to: Int.self) { try self.wrap($0) }
    }
}
